// dataFormat.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "targetver.h"
#include <iostream>
#include <string>
#include <sstream>
#include <stdio.h>
#include <tchar.h>
#include <fstream>
#include <stdio.h>
#include <vector>
#include <map>
#include <stdlib.h>
#include <time.h>
#include <ctime>
#include <algorithm>
using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
	ifstream monster;
	monster.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\Program\\Data\\SkareMonster.prn");
	if (!monster) {
		cout << "Unable to open file SkareMonster.prn";
		exit(1);   // call system to stop
	}
	ofstream fp_out;
	fp_out.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\TestData\\CarcassPattern.prn", ios::out);
	fp_out << "CP: [ ";
	int currentInput;
	int currentPattern;
	int numbIn = 0;
	int numbPat = 0;
	int numbProd = 0;
	string temp;
	vector<int> carcasses;
	map<int,int> patternNumber;
	map<int,int> plan;
	vector<int> patterns;
	map<int,int> productNumber;
	vector<int> products;
	int currentProduct;
	int lastPattern = -1;
	int lastInput = -1;
	int output[98][1094];
	int* productOutput = new int[405*1094];
	for(int i = 0; i < 405;i++){
		productOutput[i] = i;
		for(int j = 0; j < 1094;j++){
			productOutput[i*1094+j] = 0;
		}
	}
	//int productOutput[405][1094];
	for(int i = 0; i < 98; i++){
		for(int j = 0; j < 1094; j++){
			output[i][j] = 0;
		}	
	}
	for(int i = 0; i <= 4; i++){
		monster >> temp;
		
	}
	while(monster >> currentPattern){
		if(currentPattern != lastPattern){
			patternNumber[currentPattern] = numbPat;
			patterns.push_back(currentPattern);
			numbPat++;
			lastPattern = currentPattern;
			
		}
		monster >> temp;
		monster >> currentInput;
		if(currentInput != lastInput){
			carcasses.push_back(currentInput);
			numbIn++;
			lastInput = currentInput;
		}
		monster >> temp;
		monster >> temp;
		output[numbIn-1][numbPat-1] = 1;
	}
	for(int i = 0; i < 98; i++){
		for(int j = 0; j < 1094; j++){
			fp_out << output[i][j] << " ";
		}
		fp_out << "\n";
	}
	fp_out.close();
	monster.close();
	ifstream priser;
	priser.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\Program\\Data\\Varepriser.prn");
	if (!priser) {
		cout << "Unable to open file Varepriser.prn";
		exit(1);   // call system to stop
	}
	for(int i = 0; i <= 2; i++){
		priser >> temp;
	}
	while(priser >> currentProduct){
		products.push_back(currentProduct);
		productNumber[currentProduct] = numbProd;
		numbProd++;
		priser >> temp;
		priser >> temp;		
	}
	priser.close();
	fp_out.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\TestData\\PatternProduct.prn", ios::out);
	fp_out << "PP: [ ";
	ofstream fp_out2;
	fp_out2.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\TestData\\PatternID.prn", ios::out);
	fp_out2 << "PatternID: [ ";
	ifstream monster2;
	monster2.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\Program\\Data\\SkareMonster.prn");
	if (!monster2) {
		cout << "Unable to open file SkareMonster.prn";
		exit(1);   // call system to stop
	}
	for(int i = 0; i <= 4; i++){
		monster2 >> temp;
		
	}

	int readPattern = 0; 
	int readOut = 0;
	double readAmount;
	monster2 >> readPattern;
	monster2 >> readOut;
	monster2 >> temp;
	monster2 >> temp;
	monster2 >> readAmount;
	for(int i = 0; i < 1094; i++){
		fp_out << "\n";
		fp_out2 << " " << patterns[i] << "\n";
		currentPattern = patterns[i];
		for(int j = 0; j < 405; j++){
			currentProduct = products[j];
			if((readPattern == currentPattern) && (readOut == currentProduct)){
				fp_out << " " << readAmount;
				monster2 >> readPattern;
				monster2 >> readOut;
				monster2 >> temp;
				monster2 >> temp;
				monster2 >> readAmount;
			}
			else{
				fp_out << " " << 0;
			}
		}
	}
	fp_out << "\n]";
	fp_out2 << "\n]";
	monster2.close();
	fp_out.close();
	fp_out2.close();
	
	ofstream fp_out3;
	fp_out3.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\TestData\\CarcassID.prn", ios::out);
	fp_out3 << "CarcassID: [ ";
	for(int i = 0; i < carcasses.size(); i++){
		fp_out3 << " \n " << carcasses[i];
	}
	fp_out3 << "]";
	fp_out3.close();

	ifstream iPlan;
	iPlan.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\Program\\Data\\Plan.prn");
	if (!iPlan) {
		cout << "Unable to open file SkareMonster.prn";
		exit(1);   // call system to stop
	}
	for(int i = 0; i <= 4; i++){
		iPlan >> temp;
	}
	int currentAmount;
	while(iPlan >> temp){
		iPlan >> currentProduct;
		iPlan >> temp;
		iPlan >> temp;
		iPlan >> currentAmount;
		if(plan[currentProduct]){
			plan[currentProduct] += currentAmount;
		}
		else
			plan[currentProduct] = currentAmount;
	}
	iPlan.close();
	ofstream fp_out4;
	fp_out4.open("C:\\Documents and Settings\\Uno\\Desktop\\master\\TestData\\PPlan.prn", ios::out);
	fp_out4 << "Plan: [ ";
	for(int i = 0; i < products.size(); i++){
		if(plan[products[i]]){
			fp_out4 << " \n " << plan[products[i]];
		}
		else
		fp_out4 << " \n " << 0;
	}
	fp_out4 << "]";
	fp_out4.close();

	delete [] productOutput;
	return 0;
}

void sortAnimals(){
	int hei;
	
}